commit 2fd0aff2e5eb8b5b6e951916303ee27e05295791
Author: freddy77 <freddy77>
Date:   Sat Aug 16 14:48:57 2008 +0000

    allow SQL_WCHAR/SQL_WVARCHAR to be used

diff --git a/ChangeLog b/ChangeLog
index 086c144..1c9d6a7 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Sat Aug 16 16:47:21 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/odbc_util.c src/odbc/sql2tds.c:
+	- allow SQL_WCHAR/SQL_WVARCHAR
+	* src/odbc/unittests/Makefile.am src/odbc/unittests/utf8.c:
+	- add test for utf-8 encoding on client
+
 Fri Aug 15 11:55:05 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/unittests/Makefile.am:
 	- make win64 compile again
@@ -539,4 +545,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2584 2008/08/15 09:55:22 freddy77 Exp $
+$Id: ChangeLog,v 1.2585 2008/08/16 14:48:57 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index d4d5e1d..1de1ae5 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.488 2008/07/28 20:58:19 jklowden Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.489 2008/08/16 14:48:57 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -2830,7 +2830,7 @@ odbc_populate_ird(TDS_STMT * stmt)
 		/* TODO SQL_FALSE ?? */
 		drec->sql_desc_case_sensitive = SQL_TRUE;
 		/* TODO test error ?? */
-		odbc_set_concise_sql_type(odbc_server_to_sql_type(col->column_type, col->column_size), drec, 0);
+		odbc_set_concise_sql_type(odbc_server_to_sql_type(col->on_server.column_type, col->on_server.column_size), drec, 0);
 		/*
 		 * TODO how to handle when in datetime we change precision ?? 
 		 * should we change display size too ??
@@ -2846,8 +2846,16 @@ odbc_populate_ird(TDS_STMT * stmt)
 		/* TODO other types for date ?? SQL_TYPE_DATE, SQL_TYPE_TIME */
 		if (drec->sql_desc_concise_type == SQL_TIMESTAMP || drec->sql_desc_concise_type == SQL_TYPE_TIMESTAMP)
 			drec->sql_desc_length = sizeof("2000-01-01 12:00:00.0000")-1;
-		else
-			drec->sql_desc_length = col->column_size;
+		else switch (drec->sql_desc_concise_type) {
+		case SQL_WCHAR:
+		case SQL_WVARCHAR:
+		case SQL_WLONGVARCHAR:
+			drec->sql_desc_length = col->on_server.column_size / 2;
+			break;
+		default:
+			drec->sql_desc_length = col->on_server.column_size;
+			break;
+		}
 		odbc_set_sql_type_info(col, drec, stmt->dbc->env->attr.odbc_version);
 
 		if (!col->table_column_name) {
@@ -2924,7 +2932,7 @@ odbc_populate_ird(TDS_STMT * stmt)
 			else if (drec->sql_desc_type == SQL_DATETIME)
 				len = sizeof(TIMESTAMP_STRUCT);
 			else
-				len = col->column_size;
+				len = col->on_server.column_size;
 			drec->sql_desc_octet_length = len;
 		}
 
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index ddebbe1..7ba3145 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -38,7 +38,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.98 2008/07/14 15:12:42 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.99 2008/08/16 14:48:57 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -262,6 +262,14 @@ odbc_server_to_sql_type(int col_type, int col_size)
 		return SQL_VARCHAR;
 	case SYBTEXT:
 		return SQL_LONGVARCHAR;
+	case XSYBNCHAR:
+		return SQL_WCHAR;
+	/* TODO really sure ?? SYBNVARCHAR sybase only ?? */
+	case SYBNVARCHAR:
+	case XSYBNVARCHAR:
+		return SQL_WVARCHAR;
+	case SYBNTEXT:
+		return SQL_WLONGVARCHAR;
 	case SYBBIT:
 	case SYBBITN:
 		return SQL_BIT;
@@ -326,12 +334,6 @@ odbc_server_to_sql_type(int col_type, int col_size)
 	case SYBNUMERIC:
 	case SYBDECIMAL:
 		return SQL_NUMERIC;
-		/* TODO this is ODBC 3.5 */
-	case SYBNTEXT:
-	case SYBNVARCHAR:
-	case XSYBNVARCHAR:
-	case XSYBNCHAR:
-		break;
 #if (ODBCVER >= 0x0300)
 	case SYBUNIQUE:
 #ifdef SQL_GUID
@@ -679,11 +681,19 @@ odbc_sql_to_server_type(TDSSOCKET * tds, int sql_type)
 {
 
 	switch (sql_type) {
-
+	case SQL_WCHAR:
+		if (IS_TDS7_PLUS(tds))
+			return XSYBNCHAR;
 	case SQL_CHAR:
 		return SYBCHAR;
+	case SQL_WVARCHAR:
+		if (IS_TDS7_PLUS(tds))
+			return XSYBNVARCHAR;
 	case SQL_VARCHAR:
 		return SYBVARCHAR;
+	case SQL_WLONGVARCHAR:
+		if (IS_TDS7_PLUS(tds))
+			return SYBNTEXT;
 	case SQL_LONGVARCHAR:
 		return SYBTEXT;
 	case SQL_DECIMAL:
@@ -860,6 +870,9 @@ odbc_get_param_len(const struct _drecord *drec_axd, const struct _drecord *drec_
 	TYPE_NORMAL(SQL_CHAR) \
 	TYPE_NORMAL(SQL_VARCHAR) \
 	TYPE_NORMAL(SQL_LONGVARCHAR) \
+	TYPE_NORMAL(SQL_WCHAR) \
+	TYPE_NORMAL(SQL_WVARCHAR) \
+	TYPE_NORMAL(SQL_WLONGVARCHAR) \
 \
 	TYPE_NORMAL(SQL_DECIMAL) \
 	TYPE_NORMAL(SQL_NUMERIC) \
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index e2cef12..f9f118b 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -52,7 +52,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.68 2008/07/15 09:53:00 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.69 2008/08/16 14:48:57 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -354,11 +354,11 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 	case SYBLONGBINARY:
 	case SYBIMAGE:
 		res = tds_convert(dbc->env->tds_ctx, src_type, src, len, dest_type, &ores);
-		if (res < 0)
-			return SQL_ERROR;
-		blob = (TDSBLOB *) dest;
-		free(blob->textvalue);
-		blob->textvalue = ores.ib;
+		if (res >= 0) {
+			blob = (TDSBLOB *) dest;
+			free(blob->textvalue);
+			blob->textvalue = ores.ib;
+		}
 		break;
 	case SYBNUMERIC:
 	case SYBDECIMAL:
diff --git a/src/odbc/unittests/.cvsignore b/src/odbc/unittests/.cvsignore
index 6a3f662..af134ad 100644
--- a/src/odbc/unittests/.cvsignore
+++ b/src/odbc/unittests/.cvsignore
@@ -71,3 +71,5 @@ cancel
 test64
 wchar
 transaction2
+utf8
+
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index 3496168..9afecee 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.76 2008/06/12 03:52:05 jklowden Exp $
+# $Id: Makefile.am,v 1.77 2008/08/16 14:48:57 freddy77 Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -22,7 +22,7 @@ TESTS		=	\
 			cursor3$(EXEEXT) cursor4$(EXEEXT) cursor5$(EXEEXT) \
 			attributes$(EXEEXT) hidden$(EXEEXT) blob1$(EXEEXT) \
 			cancel$(EXEEXT) wchar$(EXEEXT) rowset$(EXEEXT) transaction2$(EXEEXT) \
-			cursor6$(EXEEXT) cursor7$(EXEEXT)
+			cursor6$(EXEEXT) cursor7$(EXEEXT) utf8$(EXEEXT)
 
 check_PROGRAMS	=	$(TESTS)
 
@@ -87,6 +87,7 @@ wchar_SOURCES = wchar.c common.c common.h
 transaction2_SOURCES = transaction2.c common.c common.h
 cursor6_SOURCES	= cursor6.c common.c common.h
 cursor7_SOURCES	= cursor7.c common.c common.h
+utf8_SOURCES	= utf8.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC) -DFREETDS_SRCDIR=\"$(srcdir)\"
 if MINGW32
diff --git a/src/odbc/unittests/utf8.c b/src/odbc/unittests/utf8.c
new file mode 100755
index 0000000..479dac9
--- /dev/null
+++ b/src/odbc/unittests/utf8.c
@@ -0,0 +1,169 @@
+#include "common.h"
+
+/* test binding with UTF-8 encoding */
+static char software_version[] = "$Id: utf8.c,v 1.1 2008/08/16 14:48:57 freddy77 Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+static void init_connect(void);
+
+static void
+init_connect(void)
+{
+	if (SQLAllocEnv(&Environment) != SQL_SUCCESS) {
+		printf("Unable to allocate env\n");
+		exit(1);
+	}
+	SQLSetEnvAttr(Environment, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) (SQL_OV_ODBC3), SQL_IS_UINTEGER);
+	if (SQLAllocConnect(Environment, &Connection) != SQL_SUCCESS) {
+		printf("Unable to allocate connection\n");
+		SQLFreeEnv(Environment);
+		exit(1);
+	}
+}
+
+static void
+CheckNoRow(const char *query)
+{
+	SQLRETURN retcode;
+
+	retcode = SQLExecDirect(Statement, (SQLCHAR *) query, SQL_NTS);
+	if (retcode == SQL_NO_DATA)
+		return;
+
+	if (!SQL_SUCCEEDED(retcode))
+		ODBC_REPORT_ERROR("SQLExecDirect");
+
+	do {
+		SQLSMALLINT cols;
+
+		retcode = SQLNumResultCols(Statement, &cols);
+		if (retcode != SQL_SUCCESS || cols != 0) {
+			fprintf(stderr, "Data not expected here, query:\n\t%s\n", query);
+			exit(1);
+		}
+	} while ((retcode = SQLMoreResults(Statement)) == SQL_SUCCESS);
+	if (retcode != SQL_NO_DATA)
+		ODBC_REPORT_ERROR("SQLMoreResults");
+}
+
+/* test table name, it contains two japanese characters */
+static const char table_name[] = "mytab\xe7\x8e\x8b\xe9\xb4\xbb";
+
+static const char * const strings[] = {
+	/* ascii */
+	"aaa", "aaa",
+	/* latin 1*/
+	"abc\xc3\xa9\xc3\xa1\xc3\xb4", "abc\xc3\xa9\xc3\xae\xc3\xb4",
+	/* Japanese... */
+	"abc\xe7\x8e\x8b\xe9\xb4\xbb", "abc\xe7\x8e\x8b\xe9\xb4\xbb\xe5\x82\x91\xe7\x8e\x8b\xe9\xb4\xbb\xe5\x82\x91",
+	NULL, NULL
+};
+
+/* same strings in hex */
+static const char * const strings_hex[] = {
+	/* ascii */
+	"0x610061006100", "0x610061006100",
+	/* latin 1*/
+	"0x610062006300e900e100f400", "0x610062006300e900ee00f400",
+	/* Japanese... */
+	"0x6100620063008b733b9d", "0x6100620063008b733b9d91508b733b9d9150",
+	NULL, NULL
+};
+
+int
+main(int argc, char *argv[])
+{
+	int res;
+	char tmp[2048];
+	SQLSMALLINT len;
+	const char **p;
+	SQLINTEGER n;
+	SQLLEN n_len;
+
+	if (read_login_info())
+		exit(1);
+
+	/* connect string using DSN */
+	init_connect();
+	sprintf(tmp, "DSN=%s;UID=%s;PWD=%s;DATABASE=%s;ClientCharset=UTF-8;", SERVER, USER, PASSWORD, DATABASE);
+	res = SQLDriverConnect(Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT);
+	if (!SQL_SUCCEEDED(res)) {
+		fprintf(stderr, "Unable to open data source (ret=%d)\n", res);
+		CheckReturn();
+		return 1;
+	}
+	if (!driver_is_freetds()) {
+		Disconnect();
+		printf("Driver is not FreeTDS, exiting\n");
+		return 0;
+	}
+
+        memset(tmp, 0, sizeof(tmp));
+        SQLGetInfo(Connection, SQL_DBMS_VER, tmp, sizeof(tmp), &len);
+	if (!db_is_microsoft() || (strncmp(tmp, "08.00.", 6) != 0 && strncmp(tmp, "09.00.", 6) != 0)) {
+		Disconnect();
+		printf("Test for MSSQL only\n");
+		return 0;
+	}
+
+	if (SQLAllocStmt(Connection, &Statement) != SQL_SUCCESS) {
+		printf("Unable to allocate statement\n");
+		CheckReturn();
+	}
+
+	/* create test table */
+	sprintf(tmp, "IF OBJECT_ID(N'%s') IS NOT NULL DROP TABLE %s", table_name, table_name);
+	Command(Statement, tmp);
+	sprintf(tmp, "CREATE TABLE %s (k int, c NCHAR(10), vc NVARCHAR(10))", table_name);
+	Command(Statement, tmp);
+
+	/* insert with INSERT statements */
+	for (n = 1, p = strings; p[0] && p[1]; p += 2, ++n) {
+		sprintf(tmp, "INSERT INTO %s VALUES (%d,N'%s',N'%s')", table_name, n, p[0], p[1]);
+		Command(Statement, tmp);
+	}
+
+	/* check rows */
+	for (n = 1, p = strings_hex; p[0] && p[1]; p += 2, ++n) {
+		sprintf(tmp, "IF NOT EXISTS(SELECT * FROM %s WHERE k = %d AND c = %s AND vc = %s) SELECT 1", table_name, n, p[0], p[1]);
+		CheckNoRow(tmp);
+	}
+	sprintf(tmp, "DELETE FROM %s", table_name);
+	Command(Statement, tmp);
+
+	/* insert with SQLPrepare/SQLBindParameter/SQLExecute */
+	sprintf(tmp, "INSERT INTO %s VALUES(?,?,?)", table_name);
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) tmp, SQL_NTS));
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_LONG,
+		SQL_INTEGER, 0, 0, &n, 0, &n_len));
+	n_len = sizeof(n);
+	
+	for (n = 1, p = strings; p[0] && p[1]; p += 2, ++n) {
+		SQLLEN s1_len, s2_len;
+
+		CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT, SQL_C_CHAR,
+			SQL_WCHAR, 40, 0, p[0], 0, &s1_len));
+		/* FIXME this with SQL_VARCHAR produce wrong protocol data */
+		CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_INPUT, SQL_C_CHAR,
+			SQL_WVARCHAR, 40, 0, p[1], 0, &s2_len));
+		s1_len = strlen(p[0]);
+		s2_len = strlen(p[1]);
+		printf("insert #%d\n", n);
+		CHK(SQLExecute, (Statement));
+	}
+
+	/* check rows */
+	for (n = 1, p = strings_hex; p[0] && p[1]; p += 2, ++n) {
+		sprintf(tmp, "IF NOT EXISTS(SELECT * FROM %s WHERE k = %d AND c = %s AND vc = %s) SELECT 1", table_name, n, p[0], p[1]);
+		CheckNoRow(tmp);
+	}
+
+	/* cleanup */
+	sprintf(tmp, "IF OBJECT_ID(N'%s') IS NOT NULL DROP TABLE %s", table_name, table_name);
+	Command(Statement, tmp);
+
+	Disconnect();
+	printf("Done.\n");
+	return 0;
+}
+

